#include "prjlibs-c/standards.h"
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/vt.h>
#include <sys/sysmacros.h>

#include "skalibs/include/stddjb.h"
#include "prjlibs-c/constants.h"
#include "fdtools.h"

char const* PROG="vc-switch";
#define dev_tty "/dev/tty"

int main(int argc, char** argv) {
  int fd, scan;
  unsigned int ttyno, i;

  if (argc<3)
    strerr_die3x(100, usage, PROG,
                 " {fd|/dev/ttyN} vc-number [program arg ...]");

  fd=scan_or_open(&scan, argv[1], O_RDONLY, 0);
  if (fd<0) {
    if (scan) strerr_die3x(100, PROG, ": descriptor malformed: ", argv[1]);
    else strerr_die5sys(errstat, PROG, err_unable, err_open, argv[1], ": ");
  }

  i=scan_uint(argv[2], &ttyno);
  if (i==0 || argv[2][i]!='\0')
    strerr_die3x(100, PROG, ": tty number malformed: ", argv[2]);

  if (ioctl(fd, VT_ACTIVATE, ttyno)<0)
    strerr_die3sys(errstat, PROG, err_unable, "activate console: ");
  if (!scan) close(fd);

  if (argc<4) _exit(0);
  pathexec((char const**)argv+3);
  strerr_die5sys((errno==ENOENT? 127: errstat), PROG, err_unable, err_stat,
                 argv[3], ": ");
}
